
import java.io.File;
import java.io.IOException;
import java.net.URL;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MidiEvent;
import javax.sound.midi.MidiFileFormat;
import javax.sound.midi.MidiMessage;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Sequence;
import javax.sound.midi.Sequencer;
import javax.sound.midi.Track;
import javax.sound.midi.MidiDevice.Info;

import database.DbSettings;
import file.FileBrowser;

public class Midi {

	private Note tempNote ;
	private Sequence seq;
	private Track [] tracks;
	private int eventNum;
	
	MidiEvent mevent;
	
	MidiMessage mmess;
	public static boolean isBlack (int note){
		
		int[] blacks = {61,63,66,68,70,73,75,78,80,82};
		boolean isblack = false;
		
		for (int i=0;i<blacks.length;i++){
			if (blacks[i]==note){
				isblack = true;
			}
		}
	
		return isblack;
	
	}
	public int note2posStaff (int note ){
		
		int pos = 0;
		int desp = 30;
		
		if ((note <=85 ) && (note>=72) ){
			
			desp = 0;
		}
		switch(note){
			
			//clave de sol 
			case 85: 
			case 86: pos = 15;
				break;
			case 84: pos = 25;
				break;
			case 83: 
			case 82: pos = 35;
				break;
			case 81: pos = 45;
				break;
			case 80:
			case 79: pos = 55;
				break;
			case 78:
			case 77: pos = 60;
				break;
			case 76: pos = 70;
				break;
			case 75:
			case 74: pos = 80;
				break;
			case 73:
			case 72: pos = 90;
				break;
			
			//clave de fa			
			case 71:
			case 70: pos = 110;
				break;
			case 68: 
			case 69:pos = 120; 
				break;
			case 67: pos = 125; //sol 
				break;
			case 66: //fa sostenido
			case 65: pos = 135; //fa
				break;
			case 63: //mi bemol
			case 64: pos = 145; //mi 
				break;
			
			case 62: pos = 150; //re
				break;
			case 61: // do sostenido
			case 60: pos = 160; //do
				break;

			default : pos = 0 ;
		}
		pos = pos+desp;
		
		return pos;

	}
	public int note2pos (int note){
		
		int pos = 0;
		int desp = 0;

		if ((note >= 60 ) && (note <= 84 ) ){
			if (note > 64){
				desp = 25;
			}
			if (note > 71){
				desp = desp + 25;
			}
			if (note > 76){
				desp = desp + 25;
			}
			if (note > 83){
				desp = desp + 25;
			}
			pos = ((note -59 )*25) + desp;
		
		}
		else {
			pos = 0 ;
		}
		
		return pos;
		
	}

	public int time2Duration(int time) throws MidiUnavailableException, InvalidMidiDataException{
		
		int diference = 50 ;
		int duration = 0;
		int resolution = 0;
		resolution = getresolution();

		//System.out.println(time);
		//System.out.println(resolution);
		
		if (time == resolution ){
			//negra
			duration = 3;
			
		}
		if (time > resolution  ){
			//blanca
			duration = 2;
		}
		if (time > resolution *2  ){
			// redonda
			duration = 1;
		}
		
		
		if (time < resolution ){
			//corchea 
			duration = 4;
		}
		if (time < resolution/2 ){
			//corchea semicorchea
			duration = 5;
		}
	
		//System.out.println(duration);
		return duration;
		
	}

	public int getresolution () throws MidiUnavailableException, InvalidMidiDataException{
		
		/*Sequencer seq2 = MidiSystem.getSequencer();
		seq2.setSequence(seq);
		System.out.println(seq2.getTempoInMPQ());
		System.out.println(seq2.getTempoInBPM());
		System.out.println(seq2.getTempoFactor());
		*/
		
		//System.out.println(seq.getResolution() );
		
		return seq.getResolution();
		
	}
	public int getDurationTotal () throws MidiUnavailableException, InvalidMidiDataException{
		
		return (int) seq.getMicrosecondLength()/1000;
		
	}
	public int getDurationTotalseconds () throws MidiUnavailableException, InvalidMidiDataException{
		
		return (int) seq.getMicrosecondLength()/1000000;
		
	}
	public int getDurationTotalmiliseconds () throws MidiUnavailableException, InvalidMidiDataException{
		
		return (int) (seq.getMicrosecondLength()/1000 )%1000 ;
		
	}
	public int getDurationRemaining (int time) throws MidiUnavailableException, InvalidMidiDataException{
		
		return (int) ((int) seq.getMicrosecondLength()/1000 - time);
		
	}
	public int getDurationRemainingseconds (int time) throws MidiUnavailableException, InvalidMidiDataException{
		
		return (int) ((int) seq.getMicrosecondLength()/1000 - time)/1000;
		
	}
	public int getDurationRemainingmiliseconds (int time) throws MidiUnavailableException, InvalidMidiDataException{
	
		return (int) ((int) (seq.getMicrosecondLength()/1000)- time) %1000;
	
	}
	
	public void initFile (String song) throws InvalidMidiDataException, IOException, MidiUnavailableException {

		//Info [] m = MidiSystem.getMidiDeviceInfo();
		/*
		for (int i = 0; i < m.length; i++)
		{
			System.out.println(m[i].getName());
			
		}*/
			if (Options.isOnline()){  // From URL
  				//sequence = MidiSystem.getSequence(new URL("http://89.128.145.208/piano/songs/campanitas.mid"));
  				song = song.replaceAll(" ", "%20");
				URL u = new URL( DbSettings.getUrl() +File.separator+ FileBrowser.getFolderSongs()+File.separator+ song +".mid");
  				
  				seq = MidiSystem.getSequence(u);
  				//MidiFileFormat format = MidiSystem.getMidiFileFormat(new File(dir));
  			}
  			else{ //From FILE
  				// From file Sequence sequence = MidiSystem.getSequence(new FileInputStream(song));
  		    
  				this.seq = MidiSystem.getSequence( new File(FileBrowser.getFolderSongs()+ File.separator+song+".mid"));
  			}
		
		//seq = MidiSystem.getSequence(new File(song));
	
		//divisiontipe de forma te da la unidad del tick
		//MidiFileFormat format = MidiSystem.getMidiFileFormat(new File(dir));

		
		//System.out.println(seq.getResolution() );
		/*
		System.out.println(format.getDivisionType() );
		System.out.println(format.getResolution()); //480 tick por cada format
		System.out.println(format.properties());
		*/
		
		//System.out.print(format.getProperty("author"));
		//System.out.print(format.getProperty("date"));

		//System.out.println();
		//	System.out.println("Resolution:"+seq.getResolution());
		// System.out.println("Tick length:"+seq.getTickLength());
	
		
		tracks = seq.getTracks();
	}
	
	public int gettick(int tracknumber){

		
		int tick = 0;
		tempNote = new Note();
		int ti = 0;

		Track t = tracks[tracknumber];

			
			ti++;
			if (eventNum < t.size())
			{
				
				MidiEvent mevent = t.get(eventNum);				
			
				MidiMessage mmess = mevent.getMessage();
				
				tick = ((int) mevent.getTick());
			}
			
			return tick;
		}
				
	public int gettracks(){

		return tracks.length -1;
	}
	public Note getNote(int tracknumber) throws MidiUnavailableException, InvalidMidiDataException{

		tempNote = new Note();
		int ti = 0;

		Track t = tracks[tracknumber];
		
		int duration = 0 ;
			
		ti++;
		if (eventNum < t.size())
		{
			
			MidiEvent mevent = t.get(eventNum);				
		
			MidiMessage mmess = mevent.getMessage();
			
			tempNote.setTempo((int) mevent.getTick());
	
			//System.out.println("tick: "+mevent.getTick() +",");
			/*System.out.println("status: "+mmess.getStatus() +",");
			
			System.out.println("length: "+mmess.getLength() +",");
			*/
			int bucle=0;
			for (byte b: mmess.getMessage())
			{
				
				//System.out.println("byte : "+b +",");
				switch(bucle){
				
				case 0 :
				//	System.out.println(" byte 0 : "+ (float)b +",");
					break;
				case 1:
				//	System.out.println(" byte 1 : "+b +",");
					
					//System.out.print(" Nota : "+b +",");
					tempNote.setx(this.note2pos(b));
					//System.out.println(" PosX : "+tempNote.getx() +",");
					
					tempNote.setStaffy(this.note2posStaff(b));
					
					if (tempNote.getx() > 0 ){
						
						tempNote.setStaffx(700);
						
						tempNote.setactive();
						
						tempNote.setNote(b);
						tempNote.sety(50);
						tempNote.setBlack(this.isBlack(b));
						
						//System.out.println( getFree(t, b) -mevent.getTick()) ;
						duration = getFree(t, b) - (int) mevent.getTick();
						tempNote.setDuration(this.time2Duration(duration) );
	
						if (tempNote.isBlack()){
							
							tempNote.sety(0);
						}
					}
					else{
						tempNote.setinactive();
						
						break;
					}
					
					break;
				case 2:
					//System.out.println(" byte 2 : "+b+ ",");	
					
					if (b==127){ //si es 127 es una liberacion
						tempNote.setPush(0);
						
						
						//tempNote.setinactive();
					}
					else{

						tempNote.setPush(1);
						
						//tempNote.setTempo(b);
						//System.out.println("tempo2: "+b+ ",");
					}
					break;
			
				}
				//System.out.println();
				//System.out.println(mes.getMessage());
				//System.out.print(b+",");
				bucle++;
			}

		}
		
		eventNum++;
		return tempNote;

	}
	public int getFree(Track t, int note){

		int dif = 0;
		int ti = 0;
		boolean find = false ;
		
		int eventnumaux = eventNum+1;
		int bucle = 0;
		
		MidiEvent mevent ;
		MidiMessage mmess ;
		
		mevent = t.get(eventnumaux);
		
		while ( (!find) && (eventnumaux < t.size()) ){
			//System.out.println(eventnumaux);
			mevent = t.get(eventnumaux);				
			mmess = mevent.getMessage();
			
			bucle=0;
			for (byte b: mmess.getMessage())
			{
				
				if (bucle==1 ){

					//	System.out.println(" byte 1 : "+b +",");
					//System.out.print(" Nota : "+b +",");
					//System.out.println(b);
					//System.out.println(note);
					if (b == note){
						
						find = true ;
					}
				}
				bucle++;
			}
			
			eventnumaux++;
		}
		
		return (int)mevent.getTick() ;
	
	}
	public void getallNotes(Track t){

		int dif = 0;
		int ti = 0;
		boolean find = false ;
		
		int eventnumaux = eventNum +1;
		int bucle = 0;
		
		MidiEvent mevent ;
		MidiMessage mmess ;
		
		mevent = t.get(eventnumaux);
		
		//System.out.println(t.size());
		while (eventnumaux < t.size()){
			//System.out.println(eventnumaux);
			mevent = t.get(eventnumaux);				
			mmess = mevent.getMessage();
			
			bucle=0;
			for (byte b: mmess.getMessage())
			{
				
				if (bucle==1 ){
					
						//System.out.println(b);

					find = true ;
				}
				
				//System.out.println(bucle);
				bucle++;
			}

			eventnumaux++;
				//System.out.println(eventnumaux);
		}
	}

}
